% FIGURE 5.3.3
      function FUNJ = FUNJ533(X,K,I)
%                              INTEGRAND FOR (K,I)-TH ELEMENT
%                              OF JACOBIAN MATRIX
      U  = USOL(0,X);
      Ux = USOL(1,X);
      PK  = PHI(K,0,X);
      PKx = PHI(K,1,X);
      PI  = PHI(I,0,X);
      PIx = PHI(I,1,X);
      FUNJ = -PKx*PIx - 2*Ux*PK*PIx - 2*U*PK*PI + PK*PI;
